package com.objis.demohibernate.filtres;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;
import org.hibernate.stat.Statistics;

public class FiltreSession implements Filter {

	private SessionFactory factory;
	
	public void init(FilterConfig arg0) throws ServletException {
		// Cration SessionFactory
		factory = new Configuration().configure().buildSessionFactory();
	}

	public void doFilter(ServletRequest req, ServletResponse resp, FilterChain chain) throws IOException, ServletException {
		// Cration d'une Session Hibernate
		Session session = factory.openSession();
		req.setAttribute("hibernate.session", session);
		try {
			chain.doFilter(req,  resp);
		} finally {
			if( ( session != null ) && ( session.isOpen() ) ) {
				session.close();
				Statistics stats = factory.getStatistics();
				stats.logSummary();
			}
		}
	}
	
	public void destroy() {
		
	}

}
